# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xwefcollector`](#dsc_xwefcollector): The DSC xWEFCollector resource type. Automatically generated from version 1.0.0.0
* [`dsc_xwefsubscription`](#dsc_xwefsubscription): The DSC xWEFSubscription resource type. Automatically generated from version 1.0.0.0

## Resource types

### `dsc_xwefcollector`

The DSC xWEFCollector resource type.
Automatically generated from version 1.0.0.0

#### Properties

The following properties are available in the `dsc_xwefcollector` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Determines whether the Collector service should be enabled or disabled

#### Parameters

The following parameters are available in the `dsc_xwefcollector` type.

##### `dsc_name`

namevar

Data type: `String`

Provide a unique name for the setting

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xwefsubscription`

The DSC xWEFSubscription resource type.
Automatically generated from version 1.0.0.0

#### Properties

The following properties are available in the `dsc_xwefsubscription` type.

##### `dsc_address`

Data type: `Optional[Array[String]]`

Expects an array of source node FQDNs, default source.wef.test to prevent errors when only staging test subscription

##### `dsc_allowedsourcedomaincomputers`

Data type: `Optional[String]`

In Source Initiated scenario this SDDL determines who can push events, default O:NSG:NSD:(A;;GA;;;DC)(A;;GA;;;NS) which equates to Domain Computers and Network Service

##### `dsc_allowedsourcenondomaincomputers`

Data type: `Optional[Array[String]]`

This parameter has not been fully implemented, only required for source initiated scenarios, provide XML to set IssuerCAList, AllowedSubjectList, or DeniedSubjectList if this will be used, default empty string

##### `dsc_contentformat`

Data type: `Optional[String]`

Format that event logs will be submitted in, default RenderedText

##### `dsc_credentialstype`

Data type: `Optional[Enum['Default', 'Basic', 'Negotiate', 'Digest']]`

Sets the credential type used for authenticating to WinRM, default Default

##### `dsc_deliverymode`

Data type: `Optional[Enum['Push', 'Pull']]`

Configures whether the collector will pull events from source nodes or if the source nodes will push events to the collector, default push

##### `dsc_description`

Data type: `Optional[String]`

Description of the Collector subscription

##### `dsc_enabled`

Data type: `Optional[Enum['true', 'false']]`

Sets whether the subscription will be enabled, default true

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Determines whether to validate or remove the scubscription

##### `dsc_heartbeatinterval`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Frequency to verify connectivity, default 20000

##### `dsc_locale`

Data type: `Optional[String]`

Sets the subscription Locale, default en-US

##### `dsc_logfile`

Data type: `Optional[String]`

Sets the event log that the collected events will be written to, default ForwardedEvents

##### `dsc_maxitems`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

The number of events that can occur on the source before they are submitted to the collector, default 1

##### `dsc_maxlatencytime`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The maximum amount of time that can pass before events are submitted to the collector, default 20000

##### `dsc_query`

Data type: `Optional[Array[String]]`

Expects an array of hashtables that set which events should be collected, default is all application and system logs

##### `dsc_readexistingevents`

Data type: `Optional[Enum['true', 'false']]`

Should the collector read existing or only new events, default false

##### `dsc_subscriptiontype`

Data type: `Enum['CollectorInitiated', 'SourceInitiated']`

Type of Subscription to create

##### `dsc_transportname`

Data type: `Optional[Enum['HTTP', 'HTTPS']]`

Determines whether to require SSL, default HTTP

##### `dsc_transportport`

Data type: `Optional[String]`

Set the port number that WinRM should use to make a connection, default 5985

#### Parameters

The following parameters are available in the `dsc_xwefsubscription` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_subscriptionid`

namevar

Data type: `String`

Name of the Subscription

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

