require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xwefcollector',
  dscmeta_resource_friendly_name: 'xWEFCollector',
  dscmeta_resource_name: 'MSFT_xWEFCollector',
  dscmeta_module_name: 'xWindowsEventForwarding',
  dscmeta_module_version: '1.0.0.0',
  docs: 'The DSC xWEFCollector resource type.
         Automatically generated from version 1.0.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_name: {
      type: 'String',
      desc: 'Provide a unique name for the setting',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'Determines whether the Collector service should be enabled or disabled',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
